; following steps in Seamless Wood Slat Pattern tutorial by conbagui found at link:http://fav.me/ddss6bx
; author: Pocholo
; date: 4/20/20

; Comments directed to http://gimpchat.com

; License: GPLv3
;    This program is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;    GNU General Public License for more details.
;
;    To view a copy of the GNU General Public License
;    visit: http://www.gnu.org/licenses/gpl.html


(define (script-fu-seamless-wood-slat-pattern)
    (let* (
        (theImage  (car (gimp-image-new 500 500 RGB)))
        (theLayer (car (gimp-layer-new theImage 500 500 RGB-IMAGE "Wood" 100 LAYER-MODE-NORMAL)))
		(theDesign (car (gimp-layer-new theImage 500 500 RGB "Design" 100 LAYER-MODE-NORMAL)))
		(theDivisions (car (gimp-layer-new theImage 500 500 RGB "theDivisions" 100 LAYER-MODE-NORMAL)))
				
		)
		
		(gimp-context-push)
		
		;create the image,
        (gimp-image-insert-layer theImage theLayer 0 0)
        		
		;set the fg and bg colors,
		(gimp-context-set-foreground '(232 195 151))
		(gimp-context-set-background '(184 137 82))
		(gimp-context-set-gradient-fg-bg-rgb)
		
		;add plasma2 and create wood design
		(plug-in-plasma2  RUN-NONINTERACTIVE theImage theLayer 16 0 0 0 0 0.00 1.00 2 "FG to BG")
		(plug-in-ripple RUN-NONINTERACTIVE theImage theLayer 320 800 0 1 1 TRUE TRUE)
        
		;rotate the layer
		(gimp-image-rotate theImage ROTATE-90)
		(gimp-context-set-foreground '(191 164 132))
		
		;add new layer
		(gimp-image-add-layer theImage theDesign -1)
		(gimp-drawable-fill theDesign FILL-FOREGROUND)
		(gimp-layer-set-mode theDesign LAYER-MODE-OVERLAY)
		(plug-in-hsv-noise RUN-NONINTERACTIVE theImage theDesign 8 2 4 255)
		(plug-in-wind RUN-NONINTERACTIVE theImage theDesign 15 2 45 0 0)
		(plug-in-wind RUN-NONINTERACTIVE theImage theDesign 15 3 45 0 0)
				
		(set! theLayer (car (gimp-image-merge-down theImage theDesign 1)))
		(plug-in-make-seamless RUN-NONINTERACTIVE theImage theLayer)		
		
		
		
		;create division
		(gimp-layer-new theImage 500 500 RGB "Layer" 100 LAYER-MODE-NORMAL)
		(gimp-image-insert-layer theImage theDivisions 0 0)
		(gimp-layer-add-alpha theDivisions)
		(gimp-drawable-edit-clear theDivisions)
		(gimp-context-set-background '(49 34 22))
		(plug-in-blinds RUN-NONINTERACTIVE theImage theDivisions 12 2 1 FALSE)
		
		;Create the division shadow
		(script-fu-drop-shadow theImage theDivisions 2 2 6 '(255 255 255) 100 FALSE)
		;merge layers
		(gimp-image-merge-visible-layers theImage 2)		
		
		
				
		(gimp-context-pop)
		
		(gimp-display-new theImage)	
    )

)

(script-fu-register
   "script-fu-seamless-wood-slat-pattern"                        
   "<Image>/File/Create/Seamless wood slat pattern..."
    "Creates a wood pattern"    
    "Pocholo"                            
    "Pocholo"
    "March 2020"                          
    ""
)